VERSION 5.00
Begin VB.Form frmBrightness 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00C0C0C0&
   Caption         =   "DemonSpectre's Brightness Example - GetPixel/SetPixel"
   ClientHeight    =   5655
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6285
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   377
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   419
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox ChkAutoRedraw 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      Caption         =   "AutoRedraw"
      ForeColor       =   &H80000008&
      Height          =   210
      Left            =   3120
      TabIndex        =   4
      Top             =   5280
      Value           =   1  'Checked
      Width           =   2295
   End
   Begin VB.TextBox TxtBrightness 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   4920
      TabIndex        =   2
      Text            =   "150"
      Top             =   4920
      Width           =   495
   End
   Begin VB.CommandButton CmdBrightness 
      Caption         =   "Change Brightness"
      Height          =   615
      Left            =   120
      TabIndex        =   1
      Top             =   4920
      Width           =   2895
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   4530
      Left            =   120
      Picture         =   "Brightness2.frx":0000
      ScaleHeight     =   300
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   400
      TabIndex        =   0
      Top             =   120
      Width           =   6030
   End
   Begin VB.Label Label1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Brightness Change (%):"
      Height          =   255
      Left            =   3120
      TabIndex        =   3
      Top             =   4920
      Width           =   1815
   End
End
Attribute VB_Name = "frmBrightness"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Brightness Demo 2005 by Tanner "DemonSpectre" Helland - tannerhelland@hotmail.com

'Source code for "Graphics Programming in Visual Basic - Part 2: Basic API Pixel Routines"

'This simple demo demonstrates how to adjust an image's brightness using the API calls of
'GetPixel and SetPixelV.  SetPixel is declared as a convenience - try it out if you would
'like to.  As a warning, this method is still rather slow, but it is a lot faster than PSet
'and Point; if you're still not impressed, however, you'll want to stay around for the
'next two tutorials!

'The CG graphic in the picture box is 1998 by SquareSoft
'(it's from Final Fantasy VIII, if you care)

'For additional cool code, check out the students of game design website at
'http://www.studentsofgamedesign.com

'Listen to sweet original VG music at
'www.tannerhelland.com

'The magical API function calls
Private Declare Function GetPixel Lib "GDI32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
'Private Declare Function SetPixel Lib "GDI32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function SetPixelV Lib "GDI32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Byte

'Temporary brightness variable
Dim tBrightness As Single

Private Sub ChkAutoRedraw_Click()
    'Change the AutoRedraw property of the picture box based on the check box's value
    If ChkAutoRedraw.Value = vbChecked Then Picture1.AutoRedraw = True Else Picture1.AutoRedraw = False
End Sub

Private Sub CmdBrightness_Click()
    'Get the text value, convert it to a percent of type 'Single,' and send it to the sub
    tBrightness = CSng(Val(TxtBrightness)) / 100
    DrawAPIBrightness Picture1, Picture1, tBrightness
End Sub

'A simple subroutine that will change the brightness of a picturebox using simple API routines.
Public Sub DrawAPIBrightness(DstPicture As PictureBox, SrcPicture As PictureBox, ByVal Brightness As Single)
    'Coordinate variables
    Dim x As Long, y As Long
    'Color variables
    Dim r As Long, g As Long, b As Long
    'Build a look-up table for all possible brightness values
    Dim bTable(0 To 255) As Long
    Dim TempColor As Long
    For x = 0 To 255
        'Calculate the brightness for pixel value x
        TempColor = x * Brightness
        'Make sure that the calculated value is between 0 and 255 (so we don't get an error)
        ByteMe TempColor
        'Place the corrected value into its array spot
        bTable(x) = TempColor
    Next x
    'Temporary width and height variables are faster than accessing the Scale properties over and over again
    Dim TempWidth As Long, TempHeight As Long
    TempWidth = DstPicture.ScaleWidth - 1
    TempHeight = DstPicture.ScaleHeight - 1
    'run a loop through the picture to change every pixel
    For x = 0 To TempWidth
    For y = 0 To TempHeight
        'Get the color (using GetPixel) and extract the red, green, and blue values
        TempColor = GetPixel(SrcPicture.hDC, x, y)
        r = ExtractR(TempColor)
        g = ExtractG(TempColor)
        b = ExtractB(TempColor)
        'Use the values in the look-up table to quickly change the brightness values
        'of the selected colors.  The look-up table is much faster than doing the math
        'over and over for each individual pixel.
        r = bTable(r)
        g = bTable(g)
        b = bTable(b)
        'Now set that data using the "SetPixelV" command
        SetPixelV DstPicture.hDC, x, y, RGB(r, g, b)
    Next y
        'refresh the picture box every 25 lines (a nice progress bar effect if AutoRedraw is set)
        If DstPicture.AutoRedraw = True And (x Mod 25) = 0 Then
            DstPicture.Picture = DstPicture.Image
            DstPicture.Refresh
        End If
    Next x
    'final picture refresh
    If DstPicture.AutoRedraw = True Then DstPicture.Refresh
End Sub

'Standardized routines for color extraction
Public Function ExtractR(ByVal CurrentColor As Long) As Byte
ExtractR = CurrentColor And 255
End Function

Public Function ExtractG(ByVal CurrentColor As Long) As Byte
ExtractG = (CurrentColor \ 256) And 255
End Function

Public Function ExtractB(ByVal CurrentColor As Long) As Byte
ExtractB = (CurrentColor \ 65536) And 255
End Function

'Standardized routine for converting to absolute byte values
Public Sub ByteMe(ByRef TempVar As Long)
    If TempVar > 255 Then TempVar = 255: Exit Sub
    If TempVar < 0 Then TempVar = 0: Exit Sub
End Sub
